C	*************************************************************
C	HEADMENU SHOWING CHARACTERISTICS OF ACTUAL STORED MEDIA
C	*************************************************************
	SUBROUTINE HEADMENU
	CHARACTER*10 FNAME(6)
	REAL LMIN(6),LMAX(6),F(7)
	INTEGER I
	COMMON /FNAMES/ FNAME
	COMMON /MINMAX/ LMIN,LMAX
	COMMON /FRACT/ F

10	FORMAT (/)
11	FORMAT (' Material',I2,' : ',A10,'  ',1PE9.3,' <lambda< ',
     % 1PE9.3,'  fraction:',0PF5.3)
12	FORMAT (' Material 7 : Vacuum ',5X,'0.000E+00 <lambda< infinite',
     % 3X,'fraction:',F5.3,/,/)
	WRITE (6,10)
	DO 100 I=1,6
	WRITE (6,11) I,FNAME(I),LMIN(I),LMAX(I),F(I)
100	CONTINUE
	WRITE (6,12) F(7)
	RETURN
	END

C	*************************************************************
C	INITIALISATION OF PARAMETERS
C	*************************************************************
	BLOCK DATA INITDATA
	INTEGER M(6)
	CHARACTER*10 FNAME(6)
	REAL LMIN(6),LMAX(6),F(7)
	COMMON /FNAMES/ FNAME
	COMMON /MINMAX/ LMIN,LMAX
	COMMON /FRACT/ F
	COMMON /ANZ/ M

	DATA FNAME/'          ','          ','          ',
     % '          ','          ','          '/
	DATA LMIN/0,0,0,0,0,0/
	DATA LMAX/0,0,0,0,0,0/
	DATA F/0,0,0,0,0,0,0/
	DATA M/0,0,0,0,0,0/
	END

C       *************************************************************
C       CHECK IF THE FILE IS A ".LNK", ".ZNK" OR ".LEE"-FILE
C       RECOGNITION OF THE TITLE OF THE SPECTRUM
C       *************************************************************
        SUBROUTINE NAMECHEC(FILEN,NAME,LZ)
        INTEGER EXA,NME,LZ,LZH
        CHARACTER*10 NAME
        CHARACTER*64 FILEN,HNAME,HFNAME
        CHARACTER*1 EXT1
        CHARACTER*2 EXT2
        CHARACTER*3 EXTENS

        HNAME=FILEN
200     EXA=INDEX(HNAME,'/')+1
        IF (EXA.GT.1) THEN
        HNAME=HNAME(EXA:)
        GOTO 200
        ELSE
        HFNAME=HNAME
        ENDIF

        HNAME=HFNAME
        NME=0
100     EXA=INDEX(HNAME,'.')+1
        IF (EXA.GT.1) THEN
        HNAME=HNAME(EXA:)
        NME=NME+EXA-1
        GOTO 100
        ELSE
        EXTENS=HNAME
        EXT1=EXTENS(:1)
        EXT2=EXTENS(2:)
        NAME=HFNAME(:MAX0(0,NME-1))
        ENDIF

        LZ=0
        IF(EXT2.EQ.'NK'.OR.EXT2.EQ.'nk') LZ=1
        IF(EXT2.EQ.'EE'.OR.EXT2.EQ.'ee') LZ=2
        LZH=0
        IF(EXT1.EQ.'L'.OR.EXT1.EQ.'l') LZH=1
        IF(EXT1.EQ.'Z'.OR.EXT1.EQ.'z') LZH=-1
        LZ=LZ*LZH
        RETURN
        END

C       *************************************************************
C       SUBMENU FOR THE MODIFICATION OF PARAMETERS FOR THE
C       EFFECTIVE MEDIUM CALCULATION
C       *************************************************************
        SUBROUTINE PARMMENU
        INTEGER CN,NIN,FUNC,V,I
        INTEGER CNIN(6)
        REAL CPARM(3)
	LOGICAL FAIL
        DATA NIN /0 /
        DATA CNIN/0,0,0,0,0,0/
        DATA CPARM /0.0,0.0,0.0/

11      FORMAT (' Resulting material :',$)
12      FORMAT (' Type 1-6 !')
10      FORMAT (////////////////////////////////////////////)
13      FORMAT (18X,'Parameter modification menu')
18      FORMAT (' Material',I2,' mixed from components:',6I2)
15	FORMAT (//,'  (1) Add new component',20X,'(2) Remove component',/,
     %'  (3) Change volume fractions',14X,'(4) Select wavelengths modus'
     %,/,'  (5) Calculate new effective constants',4X,'(6) Main menu')
16      FORMAT (//,' Select your function :',$)
17      FORMAT (' Type 1-6 !')
21      FORMAT (' Material',I2,' is already present in the mixture !')
100     WRITE (6,11)
        READ (5,*) CN
        IF(CN.EQ.0) RETURN
        IF(CN.GT.0.AND.CN.LT.7) GOTO 105
        WRITE (6,12)
        GOTO 100
105     CALL SEARCH(CN,CNIN,NIN,V)
        IF(V.EQ.0) GOTO 106
        WRITE (6,21) CN
        GOTO 100
106     CALL INITCN(CN,0,CPARM)
110     WRITE (6,10)
        WRITE (6,13)
        CALL HEADMENU
        WRITE (6,18) CN,(CNIN(I),I=1,NIN)
        WRITE (6,15)
130     WRITE (6,16)
        READ (5,*) FUNC
        GOTO (200,210,220,230,240,250) FUNC
        WRITE (6,17)
        GOTO 130
200     CALL ADDCOM(CN,CNIN,NIN)
        GOTO 110
210     CALL REMCOM(CN,CNIN,NIN)
        GOTO 110
220     CALL FCHANGE(CN,CNIN,NIN)
        GOTO 110
230     CALL WAVEMENU(CN,CNIN,NIN)
        GOTO 110
240     CALL CALCMENU(CN,CNIN,NIN,FAIL)
	IF (FAIL) GOTO 110
        CALL INITCN(CN,1,CPARM)
        RETURN
250     CONTINUE
        CALL INITCN(CN,1,CPARM)
        RETURN
        END

C       *************************************************************
C       INITIALISATION OF NEW MIXTURE PARAMETERS
C       *************************************************************
        SUBROUTINE INITCN(CN,KE,CPARM)
        INTEGER CN,KE
        REAL CPARM(3)
        REAL LMIN(6),LMAX(6),F(7)
        CHARACTER*10 FNAME(6)
        COMMON /FNAMES/ FNAME
        COMMON /MINMAX/ LMIN,LMAX
        COMMON /FRACT/ F

        IF (KE.EQ.0) THEN
        FNAME(CN)='Mixture'
        LMIN(CN)=CPARM(1)
        LMAX(CN)=CPARM(2)
        F(CN)=CPARM(3)
        RETURN
        ELSE
        CPARM(1)=LMIN(CN)
        CPARM(2)=LMAX(CN)
        CPARM(3)=F(CN)
        RETURN
        ENDIF
        END

C       *************************************************************
C       ROUTINE TO CHANGE THE VOLUME FRACTION OF ONE COMPOSITANT
C       OF THE EFFECTIVE MEDIUM
C       *************************************************************
        SUBROUTINE FCHANGE(CN,CNIN,NIN)
        INTEGER CN,CNIN(6),NIN
        INTEGER CNA,V
        REAL F(7),FN
        COMMON /FRACT/ F

18      FORMAT (' Material :',$)
19      FORMAT (' Type 1-7 !')
17      FORMAT (' New volume fraction f =',$)
16      FORMAT (' To change the volume fraction of the mixture treat its c
     %omposition !')
400     WRITE (6,18)
        READ (5,*) CNA
        IF(CNA.EQ.0) RETURN
        IF(CNA.NE.CN) GOTO 420
        WRITE (6,16)
        GOTO 400
420     IF(CNA.GT.0.AND.CNA.LT.8) GOTO 430
        WRITE (6,19)
        GOTO 400
430     WRITE (6,17)
        READ (5,*) FN
        CALL SEARCH(CNA,CNIN,NIN,V)
        IF(V.EQ.0) GOTO 410
        F(CN)=F(CN)-F(CNA)+FN
410     F(CNA)=FN
        RETURN
        END

C       *************************************************************
C       ROUTINE TO ADD A NEW COMPONENT TO  THE MIXTURE
C       *************************************************************
        SUBROUTINE ADDCOM(CN,CNIN,NIN)
        INTEGER CN,CNIN(6),NIN
        INTEGER CNA,V
        REAL F(7)
        REAL LMIN(6),LMAX(6)
        COMMON /FRACT/ F
        COMMON /MINMAX/ LMIN,LMAX

18      FORMAT (' Material :',$)
19      FORMAT (' Type 1-7 !')
17      FORMAT (' You cannot use the new material itself !')
16      FORMAT (' Material',I2,' is already present !')
C       *************************************************************
C       INPUT AND CHECK PROCESSES
C       *************************************************************
200     WRITE (6,18)
        READ (5,*) CNA
        IF(CNA.EQ.0) RETURN
        IF(CNA.GT.0.AND.CNA.LT.8) GOTO 210
        WRITE (6,19)
        GOTO 200
210     IF(CNA.NE.CN) GOTO 220
        WRITE(6,17)
        GOTO 200
220     CALL SEARCH(CNA,CNIN,NIN,V)
        IF(V.EQ.0) GOTO 230
        WRITE (6,16) CNA
        GOTO 200
C       *************************************************************
C       REAL ADDITION OF THE NEW COMPONENT
C       *************************************************************
230     NIN=NIN+1
        CNIN(NIN)=CNA
        F(CN)=F(CN)+F(CNA)
        IF (CNA.EQ.7) RETURN
        IF (NIN.EQ.1) THEN
        LMIN(CN)=LMIN(CNA)
        LMAX(CN)=LMAX(CNA)
        ELSE
        LMIN(CN)=AMAX1(LMIN(CN),LMIN(CNA))
        LMAX(CN)=AMIN1(LMAX(CN),LMAX(CNA))
        ENDIF
        RETURN
        END

C       *************************************************************
C       ROUTINE TO REMOVE A COMPONENT FROM THE MIXTURE
C       *************************************************************
        SUBROUTINE REMCOM(CN,CNIN,NIN)
        INTEGER CN,CNIN(6),NIN
        INTEGER CNA,V,I
        REAL F(7)
        REAL LMIN(6),LMAX(6)
        COMMON /FRACT/ F
        COMMON /MINMAX/ LMIN,LMAX

18      FORMAT (' Material :',$)
19      FORMAT (' Type 1-7 !')
17      FORMAT (' Material',I2,' is not present in the mixture !',$)
C       *************************************************************
C       INPUT AND CHECK PROCESSES
C       *************************************************************
200     WRITE (6,18)
        READ (5,*) CNA
        IF(CNA.EQ.0) RETURN
        IF(CNA.GT.0.AND.CNA.LT.8) GOTO 210
        WRITE (6,19)
        GOTO 200
210     CALL SEARCH(CNA,CNIN,NIN,V)
        IF(V.GT.0) GOTO 230
        WRITE (6,17) CNA
        GOTO 200
C       *************************************************************
C       REMOVE COMPONENT AND CALCULATE NEW MIXTURE PARAMETERS
C       *************************************************************
230     NIN=NIN-1
        DO 220 I=V,NIN
220     CNIN(I)=CNIN(I+1)
        F(CN)=F(CN)-F(CNA)
        IF (CNA.EQ.7) RETURN
        LMIN(CN)=LMIN(CNIN(1))
        LMAX(CN)=LMAX(CNIN(1))
        DO 250 I=2,NIN
        LMIN(CN)=AMAX1(LMIN(CN),LMIN(CNIN(I)))
250     LMAX(CN)=AMIN1(LMAX(CN),LMAX(CNIN(I)))
        RETURN
        END

C       *************************************************************
C       ROUTINE TO SEARCH WHERE A COMPONENT IS PRESENT IN THE MIXTURE
C       *************************************************************
        SUBROUTINE SEARCH(A,C,N,V)
        INTEGER A,C(6),N,V,I

        DO 100 I=1,N
        V=I
        IF(A.EQ.C(I)) RETURN
100     CONTINUE
        V=0
        RETURN
        END

C       ***********************************************************
C       ROUTINES TO INPUT NUMBER AND DENSITY OF WAVELENGTHS WHERE
C       N AND K SHALL BE CALCULATED
C       ***********************************************************
        SUBROUTINE WAVEMENU(CN,CNIN,NIN)
        INTEGER CN,NIN,FUNC,I
        INTEGER CNIN(6)
        REAL LMIN(6),LMAX(6)
        LOGICAL IFLG,IFZ
        COMMON /MINMAX/ LMIN,LMAX

10      FORMAT (////////////////////////////////)
13      FORMAT (23X,'Wavelengths modus menu')
15	FORMAT ('  Use a given wavelengths scale (1)',20X,'(2) Main menu',
     % /,'  Use a linear scaling      :   (3) in wavelengths',5X,'(4) in
     % wavenumbers',/,'  Use a logarithmic scaling :   (5) in wavelength
     %s',5X,'(6) in wavenumbers',/,/)
16      FORMAT (' Select your function :',$)
17      FORMAT (' Type 1-6 !')
C       *************************************************************
C       TEST IF A WAVELENGHTS RANGE IS GIVEN
C       *************************************************************
11	FORMAT (' You have to define a composition before selecting a wave
     %lengths scale !')
        IF(NIN.GT.0) GOTO 100
        WRITE (6,11)
        CALL SMLPAUSE
        RETURN
100     WRITE (6,10)
        WRITE (6,13)
        CALL HEADMENU
        WRITE (6,15)
130     WRITE (6,16)
        READ (5,*) FUNC
        IF(FUNC.GT.0.AND.FUNC.LT.7) GOTO 200
        WRITE (6,17)
        GOTO 130
200     IF(FUNC.EQ.2) RETURN
C       *************************************************************
C       INITIALISE LMIN AND LMAX
C       *************************************************************
        LMIN(CN)=0
        LMAX(CN)=1.0E5
        DO 350 I=1,NIN
        IF (CNIN(I).EQ.7) GOTO 350
        LMIN(CN)=AMAX1(LMIN(CN),LMIN(CNIN(I)))
        LMAX(CN)=AMIN1(LMAX(CN),LMAX(CNIN(I)))
350     CONTINUE
        IF(FUNC.NE.1) GOTO 210
        CALL WAVETAKE(CN)
        RETURN
210     IFLG=(FUNC.GT.4)
        IFZ=(MOD(FUNC,2).EQ.0)
        IF(IFZ) THEN
        CALL ZSCALE(CN,IFLG)
        ELSE
        CALL WAVESCAL(CN,IFLG)
        ENDIF
        RETURN
        END

C       *************************************************************
C       ROUTINE TO USE THAT WAVELENGTS GIVEN FOR ANOTHER COMPONENT
C       TO CALCULATE THE NEW OPTICAL CONSTANTS
C       *************************************************************
        SUBROUTINE WAVETAKE(CN)
        INTEGER CN,CNA,I,J,J0
        INTEGER M(6)
        REAL L(6,256),N(6,256),K(6,256)
        REAL LMIN(6),LMAX(6)
        COMMON /OPTCST/ L,N,K
        COMMON /ANZ/ M
        COMMON /MINMAX/ LMIN,LMAX

18      FORMAT (' Material :',$)
19      FORMAT (' Type 0-6 !')
17      FORMAT (' You cannot use the new material itself !')
C       *************************************************************
C       INPUT AND CHECK PROCESSES
C       *************************************************************
200     WRITE (6,18)
        READ (5,*) CNA
        IF(CNA.EQ.0) RETURN
        IF(CNA.GT.0.AND.CNA.LT.7) GOTO 210
        WRITE (6,19)
        GOTO 200
210     IF(CNA.NE.CN) GOTO 220
        WRITE(6,17)
        GOTO 200
21      FORMAT (' Old lambdamin :',E9.3,'   New lambdamin :',E9.3)
22      FORMAT (' Old lambdamax :',E9.3,'   New lambdamax :',E9.3)
23      FORMAT (' Out of wavelength region !')
220	IF(LMIN(CN).LE.L(CNA,M(CNA)).AND.LMAX(CN).GE.L(CNA,1)) GOTO 270
        WRITE (6,23)
        GOTO 200
C       *************************************************************
C       TAKE THE GIVEN WAVELENGHTS BETWEEN LMIN AND LMAX
C       *************************************************************
270     DO 230 I=1,M(CNA)
        IF(LMIN(CN).LE.L(CNA,I)) GOTO 240
230     CONTINUE
240     J=I
        J0=1
        DO 250 I=J,M(CNA)
        IF(L(CNA,I).GT.LMAX(CN)) GOTO 260
        L(CN,J0)=L(CNA,I)
        J0=J0+1
250     CONTINUE
260     M(CN)=J0-1
        WRITE (6,21) LMIN(CN),L(CN,1)
        LMIN(CN)=L(CN,1)
        WRITE (6,22) LMAX(CN),L(CN,M(CN))
        LMAX(CN)=L(CN,M(CN))
        RETURN
        END

C       *************************************************************
C       ROUTINE TO CHOSE THE SCALING IN WAVELENGTHS
C       *************************************************************
        SUBROUTINE WAVESCAL(CN,IFLG)
        INTEGER CN,NSTEP,I
        INTEGER M(6)
        LOGICAL IFLG
        REAL L(6,256),N(6,256),K(6,256)
        REAL LMIN(6),LMAX(6)
        REAL LHLP,LSTA,LSTP
        COMMON /OPTCST/ L,N,K
        COMMON /MINMAX/ LMIN,LMAX
        COMMON /ANZ/ M

200     WRITE (6,21)
21      FORMAT (//////////////////////////////////////////)
22      FORMAT (' Minimum wavelength =',1PE10.3,' cm')
23      FORMAT (' Log(min.wavelength)=',1PE10.3)
24      FORMAT (' Starting point =',$)
25      FORMAT (' Stepwidth =',$)
28      FORMAT (' Number of steps =',I4)
26      FORMAT (' Maximum wavelength =',1PE10.3,' cm')
31      FORMAT (' Log(max.wavelength)=',1PE10.3)
32	FORMAT (' Starting wavelength has to be larger than the minimal
     %one !')
35      FORMAT (' You cannot require more than 256 steps !')
36      FORMAT (' Range covered by the chosen scaling:')
        WRITE (6,22) LMIN(CN)
        IF (IFLG) WRITE(6,23) ALOG10(LMIN(CN))
        WRITE (6,24)
        READ (5,*) LSTA
        WRITE (6,25)
        READ (5,*) LSTP
        IF (IFLG) THEN
C       *************************************************************
C       LOGARITHMIC SCALING
C       *************************************************************
        LHLP=10.0**LSTA
        IF (LHLP.LT.LMIN(CN)) GOTO 260
        NSTEP=INT((ALOG10(LMAX(CN))-LSTA)/LSTP)+1
        IF(NSTEP.GT.256) GOTO 240
        DO 320 I=1,NSTEP
        L(CN,I)=LHLP
        LSTA=LSTA+LSTP
        LHLP=10.0**LSTA
320     CONTINUE
        ELSE
C       *************************************************************
C       LINEAR SCALING
C       *************************************************************
        IF (LSTA.LT.LMIN(CN)) GOTO 260
        NSTEP=INT((LMAX(CN)-LSTA)/LSTP)+1
        IF(NSTEP.GT.256) GOTO 240
        DO 220 I=1,NSTEP
        L(CN,I)=LSTA
        LSTA=LSTA+LSTP
220     CONTINUE
        ENDIF
250     M(CN)=NSTEP
        LMIN(CN)=L(CN,1)
        LMAX(CN)=L(CN,M(CN))
        WRITE (6,36)
        WRITE (6,22) LMIN(CN)
        IF (IFLG) WRITE(6,23) ALOG10(LMIN(CN))
        WRITE (6,26) LMAX(CN)
        IF(IFLG) WRITE(6,31) ALOG10(LMAX(CN))
        CALL SMLPAUSE
        RETURN
240     WRITE (6,35)
        CALL SMLPAUSE
        GOTO 200
260     WRITE (6,32)
        CALL SMLPAUSE
        GOTO 200
        END

C       *************************************************************
C       ROUTINE TO CHOSE THE SCALING IN WAVENUMBERS
C       *************************************************************
        SUBROUTINE ZSCALE(CN,IFLG)
        INTEGER CN,NSTEP,I
        INTEGER M(6)
        LOGICAL IFLG
        REAL L(6,256),N(6,256),K(6,256)
        REAL LMIN(6),LMAX(6)
        REAL LHLP,LSTA,LSTP,ZMIN
        COMMON /OPTCST/ L,N,K
        COMMON /MINMAX/ LMIN,LMAX
        COMMON /ANZ/ M

200     WRITE (6,21)
21      FORMAT (///////////////////////////////////////////)
22      FORMAT (' Minimum wavenumber =',1PE10.3,' cm^-1')
23      FORMAT (' Log(min.wavenumber)=',1PE10.3)
24      FORMAT (' Starting point =',$)
25      FORMAT (' Stepwidth =',$)
28      FORMAT (' Number of steps =',I4)
27      FORMAT (' Maximum wavenumber =',1PE10.3,' cm^-1')
29      FORMAT (' Log(max.wavenumber)=',1PE10.3)
32	FORMAT (' Starting wavenumber has to be larger than the minimal
     %one !')
35      FORMAT (' You cannot require more than 256 steps !')
36      FORMAT (' Range covered by the chosen scaling:')
        ZMIN=1.0/LMAX(CN)
        WRITE (6,22) ZMIN
        IF (IFLG) WRITE(6,23) ALOG10(ZMIN)
        WRITE (6,24)
        READ (5,*) LSTA
        WRITE (6,25)
        READ (5,*) LSTP
        IF (IFLG) THEN
C       *************************************************************
C       LOGARITHMIC SCALING
C       *************************************************************
        LHLP=10.0**(-LSTA)
        IF (LHLP.GT.LMAX(CN)) GOTO 260
        NSTEP=INT((-ALOG10(LMIN(CN))-LSTA)/LSTP)+1
        IF(NSTEP.GT.256) GOTO 240
        DO 320 I=NSTEP,1,-1
        L(CN,I)=LHLP
        LSTA=LSTA+LSTP
        LHLP=10.0**(-LSTA)
320     CONTINUE
        ELSE
C       *************************************************************
C       LINEAR SCALING
C       *************************************************************
        IF (LSTA.LT.ZMIN) GOTO 260
        NSTEP=INT((1.0/LMIN(CN)-LSTA)/LSTP)+1
        IF(NSTEP.GT.256) GOTO 240
        DO 220 I=NSTEP,1,-1
        L(CN,I)=1.0/LSTA
        LSTA=LSTA+LSTP
220     CONTINUE
        ENDIF
250     M(CN)=NSTEP
        LMIN(CN)=L(CN,1)
        LMAX(CN)=L(CN,M(CN))
        WRITE (6,36)
        WRITE (6,22) 1.0/LMAX(CN)
        IF (IFLG) WRITE(6,23) -ALOG10(LMAX(CN))
        WRITE (6,27) 1.0/LMIN(CN)
        IF(IFLG) WRITE(6,29) -ALOG10(LMIN(CN))
        CALL SMLPAUSE
        RETURN
240     WRITE (6,35)
        CALL SMLPAUSE
        GOTO 200
260     WRITE (6,32)
        CALL SMLPAUSE
        GOTO 200
        END

C       *************************************************************
C       CHECKROUTINE FOR LMIN AND LMAX, F
C       *************************************************************
        SUBROUTINE CHCKPARM(CN,KE)
        INTEGER CN,M(6)
        REAL L(6,256),N(6,256),K(6,256)
        REAL LMIN(6),LMAX(6),F(7)
        LOGICAL KE
        COMMON /OPTCST/ L,N,K
        COMMON /MINMAX/ LMIN,LMAX
        COMMON /FRACT/ F
        COMMON /ANZ/ M

        KE=.FALSE.
        IF(L(CN,M(CN)).EQ.0.0) GOTO 110
        IF(LMIN(CN).LE.L(CN,1).AND.LMAX(CN).GE.L(CN,M(CN))) GOTO 100
19	FORMAT (////////,' Wavelength range error occured. Reinitialize wa
     %velengths modus !')
110     WRITE (6,19)
        KE=.TRUE.
        CALL SMLPAUSE
        RETURN
100     IF(ABS(F(CN)-1.0).LT.1E-4) RETURN
21	FORMAT (////////,' Volume fraction error occured. Change volume fr
     %actions!')
        WRITE (6,21)
        KE=.TRUE.
        CALL SMLPAUSE
        RETURN
        END

C       *************************************************************
C       ROUTINE TO PLOT A GRAPHIC OF UP TO 4 GRAPHS
C       *************************************************************
        SUBROUTINE PLOT(XF,YF,MF,N,ORDTIT,ABSTIT,TITLE,KE)
        INTEGER IGRAPH
        INTEGER JAXES,I,J,IX,N,KE
        INTEGER MF(4)
        REAL XF(256,4),YF(256,4),X(256),Y(256)
        REAL XMIN,XMAX,YMIN,YMAX
        CHARACTER*40 TITLE
        CHARACTER*2 ORDTIT
        CHARACTER*10 ABSTIT
C
C       FIND THE MAXIMUM, AND MINIMUM OF THE VECTORS
C
  100 XMIN=XF(1,1)
      XMAX=XF(MF(1),1)
      DO 10 I = 2,N
       IF(XMIN.GT.XF(1,I)) XMIN=XF(1,I)
       IF(XMAX.LT.XF(MF(I),I)) XMAX=XF(MF(I),I)
   10 CONTINUE
      YMIN=YF(1,1)
      YMAX=YMIN
      DO 20 I = 1,N
        DO 20 J=1,MF(I)
        IF(YMIN.GT.YF(J,I)) YMIN=YF(J,I)
        IF(YMAX.LT.YF(J,I)) YMAX=YF(J,I)
   20 CONTINUE
      IF(YMIN.EQ.YMAX) YMAX=YMIN+0.1
C
C       CALCULATE THE BEST KIND OF SCALING
C
      JAXES=0
      IF(YMIN.GT.0.AND.YMAX/YMIN.GT.80.0) JAXES=JAXES+2
      IF(XMIN.GT.0.AND.XMAX/XMIN.GT.80.0) JAXES=JAXES+1
C
C       SET UP THE GRAPH, MODE TO GRAPHICS, DRAW AXES, SET UP SCALE
C
        KE=0
      CALL GRINIT(JAXES,XMIN,YMIN,XMAX,YMAX,KE)
      IF(KE.GT.0)GOTO 900
      CALL GRAXIS(1,ABSTIT)
      CALL GRAXIS(2,ORDTIT)
      CALL GRAXIS(3,TITLE)
C
C       DRAW THE LINES 
C
      DO 200 IGRAPH=1,N
      DO 300 IX=1,MF(IGRAPH)
      X(IX)=XF(IX,IGRAPH)
300   Y(IX)=YF(IX,IGRAPH)
      CALL GRDRAW(IGRAPH,MF(IGRAPH),X,Y)
200   CONTINUE
C
C       GRAPHING COMPLETE, ALLOW KEYBOARD INPUT
C
  400 CALL WAIT
C
C       RETURN SCREEN TO TEXT MODE
C
      CALL GRCLOSE
  900 RETURN
      END
