C	*************************************************************
C	ROUTINES TO PROVIDE THE BASIC GRAPHIC FUNCTIONS USING
C	THE MONGO INTERFACE ON SUNS
C	*************************************************************
C	*************************************************************
C	INITIALIZATION OF GRAPHICS SYSTEM
C	*************************************************************
	SUBROUTINE GRINIT(TYPE,XMIN,YMIN,XMAX,YMAX,KE)
	INTEGER TYPE,KE
	REAL XMIN,YMIN,XMAX,YMAX

	INTEGER IMIN,IMAX
	REAL XDMIN,XDMAX,YDMIN,YDMAX,XS,YS,DEL,POT
	LOGICAL XLOG,YLOG
	COMMON /KSYSTEM/ XLOG,YLOG,XDMIN,XDMAX,YDMIN,YDMAX

	KE=0
	CALL MGOINIT
c	Workaround for terminal problems
	CALL MGOSETUP(1)
	CALL MGOERASE
	CALL MGOBOX(1,2)
	CALL MGOTIDLE
c	Normal initialization
	CALL MGOSETUP(1)
	CALL MGOERASE
C	*************************************************************
C	PREFERENCES
C	*************************************************************
	CALL MGOSETLTYPE(0)
	CALL MGOSETLWEIGHT(1)
C	*************************************************************
C	CHECK
C	*************************************************************
	IF (TYPE.GT.3) TYPE=3
	XLOG=(MOD(TYPE,2).EQ.1)
	YLOG=(TYPE.GT.1)	
	IF (XMIN.GE.XMAX.OR.YMIN.GE.YMAX) GOTO 905
	IF (XLOG.AND.XMIN.LE.0.0) GOTO 905
	IF (YLOG.AND.YMIN.LE.0.0) GOTO 905
C	*************************************************************
C	CALCULATE USED MINIMA/MAXIMA
C	*************************************************************
	IF (XLOG) THEN
	XDMIN=NINT(ALOG10(XMIN)-0.4999)
	XDMAX=NINT(ALOG10(XMAX)+0.4999)
	ELSE
	XS=XMAX-XMIN
	DEL=XS/100.0
	POT=10.0**NINT(ALOG10(XS)-1.5)
	IMIN=NINT((XMIN-DEL)/POT-0.4999)
	IMAX=NINT((XMAX+DEL)/POT+0.4999)
 	XDMAX=IMAX*POT
 	XDMIN=IMIN*POT
	ENDIF
	IF (YLOG) THEN
	YDMIN=NINT(ALOG10(YMIN)-0.4999)
	YDMAX=NINT(ALOG10(YMAX)+0.4999)
	ELSE
	YS=YMAX-YMIN
	DEL=YS/100.0
	POT=10.0**NINT(ALOG10(YS)-1.5)
	IMIN=NINT((YMIN-DEL)/POT-0.4999)
	IMAX=NINT((YMAX+DEL)/POT+0.4999)
 	YDMAX=IMAX*POT
 	YDMIN=IMIN*POT
	ENDIF
C	*************************************************************
C	BOX
C	*************************************************************
	CALL MGOSETLIM(XDMIN,YDMIN,XDMAX,YDMAX)
	GOTO (420,430,440) TYPE
410	CALL MGOTICKSIZE(0.0,0.0,0.0,0.0)
	GOTO 450
420	CALL MGOTICKSIZE(-1.0,0.0,0.0,0.0)
	GOTO 450
430	CALL MGOTICKSIZE(0.0,0.0,-1.0,0.0)
	GOTO 450
440	CALL MGOTICKSIZE(-1.0,0.0,-1.0,0.0)
450	CONTINUE
	CALL MGOBOX(1,2)
	RETURN
C       *************************************************************
C       ERROR HANDLING
C       *************************************************************
905     CALL GRCLOSE
10      FORMAT (' Graphics error occured !')
910     KE=1
        WRITE (6,10)
        RETURN
        END

C	*************************************************************
C	MAKE AXIS DESCRIPTIONS
C	*************************************************************
	SUBROUTINE GRAXIS(NUM,STRING)
	INTEGER NUM,LE
	REAL X,Y
	CHARACTER*(*) STRING
	character*10 outstr

	REAL XDMIN,XDMAX,YDMIN,YDMAX
	LOGICAL XLOG,YLOG
	COMMON /KSYSTEM/ XLOG,YLOG,XDMIN,XDMAX,YDMIN,YDMAX

	outstr=string
	le=len(outstr)
	IF (NUM.EQ.1) THEN
	CALL MGOXLABEL(le,OUTSTR)
	ELSE IF (NUM.EQ.2) THEN
	CALL MGOYLABEL(le,OUTSTR)
	ELSE
	X=XDMIN+0.25*(XDMAX-XDMIN)
	Y=YDMAX+0.01*(YDMAX-YDMIN)
	CALL GRPRINT(X,Y,STRING)
	ENDIF
	RETURN
	END


C	*************************************************************
C	PRINT ON GRAPHICS SCREEN
C	*************************************************************
	SUBROUTINE GRPRINT(X,Y,STRING)
	REAL X,Y
	INTEGER LE
	CHARACTER*(*) STRING
	character*40 outstr

	outstr=string
	LE=LEN(OUTSTR)
	CALL MGORELOCATE(X,Y)
	CALL MGOPUTLABEL(le,outstr,9)
	CALL MGOPUTLABEL(10,'          ',9)
	RETURN
	END

C	*************************************************************
C	DRAW GRAPH LINE
C	*************************************************************
	SUBROUTINE GRDRAW(NCOL,N,X,Y)
	REAL X(*),Y(*),XX,YY
	INTEGER N,NCOL
	INTEGER I

	CALL MGOSETLTYPE(NCOL)
	CALL COORD(X(1),Y(1),XX,YY)
	CALL MGORELOCATE(XX,YY)
	DO 100 I=2,N
	CALL COORD(X(I),Y(I),XX,YY)
	CALL MGODRAW(XX,YY)
100	CONTINUE
	RETURN
	END

C	*************************************************************
C	WAIT UNTIL KEYPRESSED
C	*************************************************************
	SUBROUTINE WAIT
	call mgobox(1,2)
	READ (5,*)
	RETURN
	END

C	*************************************************************
C	CLOSE GRAPHICS
C	*************************************************************
	SUBROUTINE GRCLOSE
	CALL MGOERASE
	CALL MGOTIDLE
	CALL MGOTCLOSE
	RETURN
	END

C	*************************************************************
C	KOORDINATENTRAFO
C	*************************************************************
	SUBROUTINE COORD(X,Y,XX,YY)
	REAL X,Y,XX,YY,XF,YF,XC,YC
	LOGICAL XLOG,YLOG
	COMMON /KSYSTEM/ XLOG,YLOG,XF,YF,XC,YC

	IF(XLOG) THEN
	XX=ALOG10(X)
	ELSE
	XX=X
	ENDIF
	IF(YLOG) THEN
	YY=ALOG10(Y)
	ELSE
	YY=Y
	ENDIF
	RETURN
	END

C	*************************************************************
C	MACHINE DEPENDENT PAUSE LOOP
C	*************************************************************
	SUBROUTINE SMLPAUSE

	CALL SLEEP(3)
	RETURN
	END

