C	*************************************************************
C	SUBMENU FOR THE KIND OF EFFECTIVE MEDIUM CALCULATION
C	*************************************************************
	SUBROUTINE CALCMENU(CN,CNIN,NIN,FAIL)
	INTEGER CN,NIN,FUNC
	INTEGER CNIN(6),I
	CHARACTER*10 FNAME(6)
	LOGICAL KE,FAIL
	COMMON /FNAMES/ FNAME

10      FORMAT(///////////////////////////////////////////)
11	FORMAT (14X,' Effective media theories menu')
12	FORMAT (' Material',I2,' mixed from components:',6I2)
13	FORMAT (/,' Following theories are available :',/)
14	FORMAT (13X,' Seperated grains (like Maxwell-Garnett)   (1)',/,
     % 13X,' Aggregate structure (like Bruggeman)      (2)',//,
     % 13X,' Last menu                                 (3)',/)
16	FORMAT (' Select your function :',$)
17	FORMAT (' Type 1-3 !')
18	FORMAT (////////,' This program only allows the combination of'
     %  ,' 2 substances !')
C	*************************************************************
C	CHECK IF ALL NECESSARY INPUT HAS BEEN DONE
C	*************************************************************
	FAIL=.TRUE.
	IF (NIN.EQ.2) GOTO 110
	WRITE (6,18)
	CALL SMLPAUSE
	RETURN
110	CALL CHCKPARM(CN,KE)
	IF (KE) RETURN
	FAIL=.FALSE.
C	*************************************************************
C	BUILD UP THE MENU
C	*************************************************************
120	WRITE (6,10)
	WRITE (6,11)
	CALL HEADMENU
	WRITE (6,12) CN,(CNIN(I),I=1,NIN)
	WRITE (6,13)
	WRITE (6,14)
100	WRITE (6,16)
	READ (5,*) FUNC
	GOTO (200,210,220) FUNC
	WRITE (6,17)
	GOTO 100
200	CALL EMGT(CN,CNIN)
	RETURN
210	CALL EBGT(CN,CNIN)
220	RETURN
	END

C	*************************************************************
C	LIN. INTERPOLATION OF OPTICAL CONSTANTS BETWEEN GIVEN POINTS
C	*************************************************************
	SUBROUTINE VALUEMUAT(CN,CNIN,NH,KH,MURH,MUIH,NIN,INDH)
	INTEGER CN,NIN,CNIN(6)
	INTEGER INDH(6),M(6),CNJ,I,J
	REAL L(6,256),N(6,256),K(6,256),MUR(6,256),MUI(6,256)
	REAL NH(6),KH(6),MURH(6),MUIH(6),LC,A
	COMMON /OPTCST/ L,N,K,MUR,MUI
	COMMON /ANZ/ M

	LC=L(CN,INDH(CN))
	DO 100 J=1,NIN
	CNJ=CNIN(J)
	IF(CNJ.EQ.7) GOTO 150
	DO 200 I=INDH(CNJ),M(CNJ)
	IF (L(CNJ,I).EQ.LC) THEN
	  NH(J)=N(CNJ,I)
	  KH(J)=K(CNJ,I)
	  MURH(J)=MUR(CNJ,I)
	  MUIH(J)=MUI(CNJ,I)
	  GOTO 100
	ENDIF
	IF (L(CNJ,I).GT.LC) THEN
	  A=(LC-L(CNJ,I-1))/(L(CNJ,I)-L(CNJ,I-1))
	  NH(J)=N(CNJ,I-1)*(1-A)+N(CNJ,I)*A
	  KH(J)=K(CNJ,I-1)*(1-A)+K(CNJ,I)*A
	  MURH(J)=MUR(CNJ,I-1)*(1-A)+MUR(CNJ,I)*A
	  MUIH(J)=MUI(CNJ,I-1)*(1-A)+MUI(CNJ,I)*A
	  GOTO 100
	ENDIF
200	CONTINUE
11	FORMAT (////////,' Wavelength range error occured - Reinitialize',
     %  ' wavelength modus !')
	WRITE (6,11)
        CALL SMLPAUSE
	RETURN
150	NH(J)=1.0
	KH(J)=0.0
	MURH(J)=1.0
	MUIH(J)=0.0
100	CONTINUE
	RETURN
	END

C	*************************************************************
C	CALCULATION OF EFFECTIVE CONSTANTS IN MAXWELL-GARNETT LIKE
C	APPROXIMATION WITHOUT RESTRICTION TO THE PERMEABILITIES
C	*************************************************************
	SUBROUTINE EMGT(CN,CNIN)
	INTEGER CN,CNIN(6)
	INTEGER INDX(6),M(6),JJ,I
	INTEGER MNT,C
	REAL L(6,256),N(6,256),K(6,256),MUR(6,256),MUI(6,256)
	REAL F(7),RR,VV,VH
	REAL NH(6),KH(6),MURH(6),MUIH(6)
	REAL LC,PI2,RX,X
	COMPLEX E(6),MUE(6),MUEX,MUEXST,EMUE,MPS
	COMPLEX HSUM(0:2),A,B,A1,A2
	COMMON /OPTCST/ L,N,K,MUR,MUI
	COMMON /ANZ/ M
	COMMON /FRACT/ F
	DATA PI2 / 6.2831853 /

C	*************************************************************
C	SELECT SIZES
C	*************************************************************
12	FORMAT (' Which component forms the inclusions    :',$)
11	FORMAT (/,' Radius of the inclusions (material',I2,') [cm] :',$)
	WRITE (6,12)
	READ (5,*) C
	IF (C.EQ.CNIN(1)) THEN
	C=1
	MNT=2
	ELSE
	C=2
	MNT=1
	ENDIF
	WRITE (6,11) CNIN(C)
	READ (5,*) RR
	DO 190 I=1,3
190	INDX(I)=1
	VV=F(CNIN(C))
	VH=VV**(2.0/3.0)
C	*************************************************************
C	CONSTANTS AT THE GIVEN WAVELENGTHS
C	*************************************************************
        DO 200 JJ=1,M(CN)
        LC=L(CN,JJ)
        RX=(PI2*RR*VH/(LC*VV))**2
        INDX(CN)=JJ
        CALL VALUEMUAT(CN,CNIN,NH,KH,MURH,MUIH,2,INDX)
        DO 210 I=1,2
        MUE(I)=CMPLX(MURH(I),MUIH(I))
210     E(I)=CMPLX(NH(I),KH(I))**2
        MUEXST=CMPLX(1.0,0.0)
C       *************************************************************
C       ERSTER SCHRITT - EPSILON
C       *************************************************************
        A1=E(C)+2.0*E(MNT)
        A2=E(C)-E(MNT)
        EMUE=(A1+2.0*VV*A2)/(A1-VV*A2)*E(MNT)
C       *************************************************************
C       COEFFICIENTS
C       *************************************************************
        X=RX*REAL(SQRT(EMUE))**2
        A1=MUE(C)+2.0*MUE(MNT)
        A2=MUE(C)-MUE(MNT)
800     HSUM(2)=(A1-VV*A2)**2*(12.0*X-20.0)
        HSUM(1)=(A1+2.0*A2)*(A1-A2)*MUE(MNT)*(10.0-18.0*X)
        HSUM(0)=A1**2*MUE(MNT)**2*(10.0+3.0*X*(EMUE+E(MNT))/EMUE)
     % +VV*A1*A2*MUE(MNT)**2*(40.0+6*X*(2.0*EMUE+5.0*E(MNT))/EMUE)
     % +VV**2*A2**2*MUE(MNT)**2*(40.0+12.0*X*(EMUE-5.0*E(MNT))/EMUE)
     % +VV*VH*MUE(MNT)**2*X*27.0*(MUE(C)**2*(E(C)+E(MNT))+E(MNT)*
     % (4.0*MUE(MNT)**2-6.0*MUE(MNT)*MUE(C)))/EMUE
        IF (CABS(HSUM(2)).LT.1E-3*CABS(HSUM(1))) GOTO 540
C       *************************************************************
C       SOLVE QUADRATIC EQUATION
C       *************************************************************
        HSUM(1)=HSUM(1)/HSUM(2)
        HSUM(0)=HSUM(0)/HSUM(2)
        A=HSUM(1)*CMPLX(-0.5,0.0)
        B=CSQRT(A**2-HSUM(0))
        MUEX=A+B
        IF (AIMAG(MUEX).LT.0.0) MUEX=A-B
        GOTO 530
C       *************************************************************
C       LINEAR EQUATION
C       *************************************************************
540     MUEX=-HSUM(0)/HSUM(1)
C       *************************************************************
C       ITERATION
C       *************************************************************
530     IF (ABS(MUEX-MUEXST).GT.1E-4) THEN
        X=RX*REAL(SQRT(EMUE*MUEX))**2
        MUEXST=MUEX
        GOTO 800
        ENDIF 
        MPS=CSQRT(EMUE)
92      FORMAT (E9.2,' ',E11.4,' ',E11.4,' ',E11.4,' ',E11.4)
        WRITE (6,92) L(CN,JJ),EMUE,MUEX
        N(CN,JJ)=REAL(MPS)
        K(CN,JJ)=AIMAG(MPS)
        MUR(CN,JJ)=REAL(MUEX)
        MUI(CN,JJ)=AIMAG(MUEX)
200     CONTINUE
        RETURN
	END

C	*************************************************************
C	CALCULATION OF EFFECTIVE CONSTANTS IN BRUGGEMAN LIKE
C	APPROXIMATION WITHOUT RESTRICTION TO THE PERMEABILITIES
C	*************************************************************
	SUBROUTINE EBGT(CN,CNIN)
	INTEGER CN,CNIN(6)
	INTEGER INDX(6),M(6),JJ,I
	REAL L(6,256),N(6,256),K(6,256),MUR(6,256),MUI(6,256)
	REAL F(7),MOM(2),MOMX(2),FL(2),X(2)
	REAL NH(6),KH(6),MURH(6),MUIH(6)
	REAL CRMUE(2),CRX(2)
	REAL LC,PI2
	COMPLEX E(6),MUE(6),EMUE,MPS,EH1,EH2,MUH1,MUH2
	COMPLEX MUEX,MUEXST
	COMMON /OPTCST/ L,N,K,MUR,MUI
	COMMON /ANZ/ M
	COMMON /FRACT/ F
	DATA PI2 / 6.2831853 /

C	*************************************************************
C	SELECT SIZES
C	*************************************************************
11	FORMAT (/,' Radius of the spheres formed by material',I2,
     % ' [cm] :',$)
	DO 120 I=1,2
	WRITE (6,11) CNIN(I)
	READ (5,*) MOM(I)
120	CONTINUE
	FL(1)=F(CNIN(1))
	FL(2)=F(CNIN(2))
	DO 190 I=1,3
190	INDX(I)=1
C	*************************************************************
C	CONSTANTS AT THE GIVEN WAVELENGTHS
C	*************************************************************
	DO 200 JJ=1,M(CN)
	LC=L(CN,JJ)
	INDX(CN)=JJ
	CALL VALUEMUAT(CN,CNIN,NH,KH,MURH,MUIH,2,INDX)
	DO 210 I=1,2
	MOMX(I)=(PI2*MOM(I)/LC)**2
	E(I)=CMPLX(NH(I),KH(I))**2
210	MUE(I)=CMPLX(MURH(I),MUIH(I))
C       *************************************************************
C       FIRST STEP - EPSILON
C       *************************************************************
        MUH1=0.25*(FL(1)*(2.0*E(1)-E(2))+FL(2)*(2.0*E(2)-E(1)))
        MUH2=CSQRT(MUH1**2+0.5*E(1)*E(2))
        EMUE=MUH1-MUH2
        IF (AIMAG(EMUE).LT.0.0) EMUE=MUH1+MUH2
C       *************************************************************
C       SECOND STEP - MUE
C       *************************************************************
        MUEXST=CMPLX(1.0,0.0)
C       *************************************************************
C       DETERMINATION WHICH APPROXIMATION IS VALID
C       *************************************************************
        CRMUE(1)=ABS(MUE(1)-CMPLX(1.0))
        CRMUE(2)=ABS(MUE(2)-CMPLX(1.0))
        CRX(1)=0.133*MOMX(1)*REAL(SQRT(EMUE))**2
        CRX(2)=0.133*MOMX(2)*REAL(SQRT(EMUE))**2
12      FORMAT (' crm=',E11.4,' ',E11.4,' crx=',E11.4,' ',E11.4)
        WRITE (6,12) CRMUE,CRX
        IF (CRMUE(1)+CRMUE(2)+0.0002.LT.CRX(1)+CRX(2)) GOTO 340
C       *************************************************************
C       X**2*ABS(EPS)<<1 APPROXIMATION
C       *************************************************************
13      FORMAT (' x=0 - Approximation applied !')
        WRITE (6,13)
        MUH1=(FL(1)*(2.0*MUE(1)-MUE(2))+FL(2)*(2.0*MUE(2)-MUE(1)))/4.0
        MUH2=CSQRT(MUH1**2+MUE(1)*MUE(2)/2.0)
        MUEX=MUH1+MUH2
        IF (AIMAG(MUEX).LT.0.0) MUEX=MUH1-MUH2
        GOTO 250
C       *************************************************************
C       MUE-APPROXIMATION
C       *************************************************************
14      FORMAT(' m=1.0 - Approximation applied !')
340     WRITE (6,14)
        DO 125 I=1,2
125     X(I)=MOMX(I)*REAL(SQRT(EMUE))**2
800     EH1=FL(1)*X(1)+FL(2)*X(2)
        EH2=(FL(1)*X(1)*E(1)+FL(2)*X(2)*E(2))/EMUE
        MUH1=(9.0*EH1-5.0)/(12.0*EH1-20.0)
        MUH2=CSQRT(MUH1**2-(3.0*(EH1+EH2)+10.0)/(12.0*EH1-20.0))
        MUEX=MUH1+MUH2
        IF (AIMAG(MUEX).LT.0.0) MUEX=MUH1-MUH2
C       ************************************************************
C       ITERATION
C       ************************************************************
530     IF (ABS(MUEX-MUEXST).GT.1E-4) THEN
        DO 135 I=1,2
135     X(I)=MOMX(I)*REAL(SQRT(EMUE*MUEX))**2
        MUEXST=MUEX
        GOTO 800
        ENDIF 
C       ************************************************************
C       ENDE
C       ************************************************************
250     CONTINUE
        MPS=CSQRT(EMUE)
92      FORMAT (E9.2,' ',E11.4,' ',E11.4,' ',E11.4,' ',E11.4)
        WRITE (6,92) L(CN,JJ),EMUE,MUEX
        N(CN,JJ)=REAL(MPS)
        K(CN,JJ)=AIMAG(MPS)
        MUR(CN,JJ)=REAL(MUEX)
        MUI(CN,JJ)=AIMAG(MUEX)
200     CONTINUE
        RETURN
51      FORMAT (' File error !')
150     WRITE (6,51)
        RETURN
        END
