C	*************************************************************
C	PROGRAM TO CALCULATE OPTICAL CONSTANTS OF COMPOSITE MEDIA
C	*************************************************************
	PROGRAM EFFMED
	INTEGER FUNC
	CHARACTER*1 GC
	EXTERNAL INITDATA

C	*************************************************************
C	MAIN SELECTION MENU
C	*************************************************************
12      FORMAT (/////////////////////////////////////////////)
13	FORMAT (9X,' Effective media calculator with magnetic dipoles')
15	FORMAT ('  (1) Read optical constants',17X,
     % '(2) Save optical constants',/,'  (3) Calculation / Modification 
     %menu',8X,'(4) Graphic',/,'  (5) Quit',/)
16	FORMAT (' Select your function :',$)
17	FORMAT (' Type 1-5 !')
120	WRITE (6,12)
	WRITE (6,13)
	CALL HEADMENU
	WRITE (6,15)
130	WRITE (6,16)
	READ (5,*) FUNC
	GOTO (200,210,220,230,240) FUNC
	WRITE (6,17)
	GOTO 130
200	CALL READCNST
	GOTO 120
210	CALL SAVECNST
	GOTO 120
220	CALL PARMMENU
	GOTO 120
230	CALL GRAPHIC
	GOTO 120
21	FORMAT (' Have you saved all spectra ? :',$)
22	FORMAT (A1)
240	WRITE (6,21)
	READ (5,22) GC
	IF (GC.NE.'Y'.AND.GC.NE.'y') GOTO 120
	END

C	*************************************************************
C	SUBROUTINE TO SHOW OPTICAL CONSTANTS OF UP TO 3 COMPONENTS
C	GRAPHICALLY
C	*************************************************************
	SUBROUTINE GRAPHIC
	INTEGER CN,CNIN(4),NIN,I,J,EK
	INTEGER M(6),NN(4)
	REAL L(6,256),N(6,256),K(6,256),MUR(6,256),MUI(6,256)
	REAL XF(256,4),YF(256,4)
	CHARACTER*2 ORDTIT,ORD(4)
	CHARACTER*10 ABSTIT
        CHARACTER*40 TITLE
	CHARACTER GC
	COMMON /OPTCST/ L,N,K,MUR,MUI
	COMMON /ANZ/ M
        DATA ORD / 'n','k',"u'",'u"'/

C	*************************************************************
C	INPUT OF SPECTRA OF THE COMPONENTS
C	*************************************************************
18	FORMAT (I2,'. Material to plot :',$)
19	FORMAT (' Type 0-6 !')
	NIN=0
	DO 120 I=1,4
100	WRITE (6,18) I
	READ (5,*) CN
	IF(CN.EQ.0) RETURN
	IF(CN.GT.0.AND.CN.LT.7) GOTO 130
	WRITE (6,19)
	GOTO 100
130	NIN=NIN+1
	CNIN(I)=CN
	NN(I)=M(CN)
21	FORMAT (' Still another component ? :',$)
22	FORMAT (A1)
	IF (I.EQ.4) GOTO 120
	WRITE (6,21)
	READ (5,22) GC
	IF (GC.NE.'Y'.AND.GC.NE.'y') GOTO 150
120	CONTINUE

23	FORMAT (//////////////,
     % ' Error occured in graphics mode - try to continue !')
C	*************************************************************
C	SHOW N(LAMBDA)
C	*************************************************************
150	DO 200 J=1,NIN
	DO 200 I=1,NN(J)
	XF(I,J)=L(CNIN(J),I)
200	YF(I,J)=N(CNIN(J),I)
        TITLE=' '
	ABSTIT='wavelength'
	ORDTIT=ORD(1)
        CALL PLOT(XF,YF,NN,NIN,ORDTIT,ABSTIT,TITLE,EK)
	IF(EK.EQ.0) GOTO 220
	WRITE (6,23)
        CALL SMLPAUSE
C	*************************************************************
C	SHOW K(LAMBDA)
C	*************************************************************
220	DO 230 J=1,NIN
	DO 230 I=1,NN(J)
230	YF(I,J)=K(CNIN(J),I)
	ORDTIT=ORD(2)
        CALL PLOT(XF,YF,NN,NIN,ORDTIT,ABSTIT,TITLE,EK)
	IF(EK.EQ.0) GOTO 240
	WRITE (6,23)
        CALL SMLPAUSE
C	*************************************************************
C	SHOW MUR(LAMBDA)
C	*************************************************************
240	DO 250 J=1,NIN
	DO 250 I=1,NN(J)
250	YF(I,J)=MUR(CNIN(J),I)
	ORDTIT=ORD(3)
        CALL PLOT(XF,YF,NN,NIN,ORDTIT,ABSTIT,TITLE,EK)
	IF(EK.EQ.0) GOTO 260
	WRITE (6,23)
        CALL SMLPAUSE
C	*************************************************************
C	SHOW MUI(LAMBDA)
C	*************************************************************
260	DO 270 J=1,NIN
	DO 270 I=1,NN(J)
270	YF(I,J)=MUI(CNIN(J),I)
	ORDTIT=ORD(4)
        CALL PLOT(XF,YF,NN,NIN,ORDTIT,ABSTIT,TITLE,EK)
	IF(EK.EQ.0) GOTO 280
	WRITE (6,23)
        CALL SMLPAUSE
280	RETURN
	END

